function dobiInfo() {
    let stat = [];
    let statStorage = localStorage.getItem("stat");
    if (statStorage != null) {
      stat = JSON.parse(statStorage);
    }    
    return stat;
}

$(() => {
  var sleep = time => new Promise(res => setTimeout(res, time));

  let igramo = false;

  let stNeodkritihMin;
  let vel;
  let stMin;
  let data = [];

  let cas = 0;
  let casInterval;

  $("#btnZacni").click(() => {
    igramo = true;

    vel = $("#velikost")
      .children("option:selected")
      .data("vel");
    stMin = $("#velikost")
      .children("option:selected")
      .data("min");

    stNeodkritihMin = stMin;
    $("#stMin").text(stNeodkritihMin);

    clearInterval(casInterval);
    cas = 1;
    casInterval = setInterval(() => $("#cas").text(cas++), 1000);
    $("#info").show();

    // inicializiramo podatke za igralno polje
    data = [];
    while (data.push([...Array(vel)].map(_ => 0)) < vel);

    // dodamo naključne mine v podatke
    let stDodanihMin = 0;
    while (stDodanihMin < stMin) {
      let randX = Math.floor(Math.random() * vel);
      let randY = Math.floor(Math.random() * vel);
      if (data[randX][randY] != -1) {
        data[randX][randY] = -1;
        stDodanihMin++;
      }
    }

    // prestejemo mine in nastavimo podatke
    for (let x = 0; x < vel; x++) {
      for (let y = 0; y < vel; y++) {
        let stMinPolje = 0;
        if (data[x][y] == -1) continue;
        for (let i = -1; i <= 1; i++) {
          for (let j = -1; j <= 1; j++) {
            if (data[x + i] != undefined && data[x + i][y + j] == -1)
              stMinPolje++;
          }
        }
        data[x][y] = stMinPolje;
      }
    }

    // iniciliziramo html polje
    $("#minolovec").empty();
    for (let x = 0; x < vel; x++) {
      let row = $("<tr>");
      for (let y = 0; y < vel; y++) {
        let cell = $("<td>");
        cell.data("x", x);
        cell.data("y", y);
        cell.click(klikPolja);
        cell.bind("contextmenu", klikZastava);
        row.append(cell);
      }
      $("#minolovec").append(row);
    }
  });

  function klikZastava(e) {
    if (!igramo) return;
    let x = $(e.target).data("x");
    let y = $(e.target).data("y");

    if (data[x][y] == -2) return false; // polje je že odprto

    $(e.target).toggleClass("zastava");

    if ($(e.target).hasClass("zastava")) stNeodkritihMin--;
    else stNeodkritihMin++;

    $("#stMin").text(stNeodkritihMin);

    return false;
  }

  async function klikPolja(e) {
    if (!igramo) return;
    let x = $(e.target).data("x");
    let y = $(e.target).data("y");

    await prikaziPolje(x, y);

    // če je bila bomba
    if (!igramo) return;
    // preveri konec
    let jeKonec = preveriKonec();
    if (jeKonec) konec(true);
  }

  function preveriKonec() {
    for (let x = 0; x < vel; x++) {
      for (let y = 0; y < vel; y++) {
        if (data[x][y] >= 0) return false;
      }
    }
    return true;
  }

  function konec(uspel = false) {
    igramo = false;
    clearInterval(casInterval);
    // odpremo vsa polja
    for (let x = 0; x < vel; x++) {
      for (let y = 0; y < vel; y++) {
        prikaziPolje(x, y); // klic rekurzivne funkcije
      }
    }
    if (uspel) {
      var ime = prompt("Vpišite ime!");
      // Dodamo na seznam
      let stat = dobiInfo();
      stat.push({ ime: ime, cas: cas, vel: vel });
      localStorage.setItem("stat", JSON.stringify(stat));
    }
  }

  // rekurzivna funkcija, ki prikazuje polja s časovnim zamikom
  async function prikaziPolje(x, y) {
    if (x < 0 || y < 0 || x >= vel || y >= vel) return;
    if (data[x][y] == -2) return; // če je polje odprto
    let polje = $("table tr")
      .eq(x)
      .children()
      .eq(y);
    
    polje.removeClass("zastava");

    if (data[x][y] == -1) {
      polje.addClass("mina");
      if (igramo) {
        polje.addClass("rdece");
        konec(false);
      }
    } else if (data[x][y] > 0) {
      polje.addClass("prazno");
      polje.text(data[x][y]);
    } else {
      polje.addClass("prazno");
      await sleep(200);
      // prikažemo sosednja polja
      for (let i = -1; i <= 1; i++) {
        for (let j = -1; j <= 1; j++) {
          if (i != 0 || j != 0) prikaziPolje(x + i, y + j);
        }
      }
    }
    // nastavimo, da je polje odprto
    data[x][y] = -2;
  }

  // Pri zapiranju opozorimo uporabnika, da je sredi igre
  $(window).on("beforeunload", function() {
    if (igramo) return "Želite zapustiti neodigrano igro?";
  });
});
